/*
 * Created on 2005-4-17
 *
 */
package com.test.subject.commands;

import org.eclipse.gef.commands.Command;

import com.test.subject.model.Guide;
import com.test.subject.model.ModelFactory;
import com.test.subject.model.Ruler;

/**
 * @author Administrator
 *
 */
public class CreateGuideCommand extends Command {
    private Guide guide;

    private Ruler ruler;

    private int position;

    public CreateGuideCommand(Ruler parent, int position) {
        setLabel("Create Guide");
        this.ruler = parent;
        this.position = position;
    }

    public void execute() {
        guide = ModelFactory.eINSTANCE.createGuide();
        guide.setHorizontal(!ruler.isHorizontal());
        guide.setPosition(position);
        ruler.getGuides().add(guide);
    }

    public void redo() {
        execute();
    }

    public void undo() {
        ruler.getGuides().remove(guide);
    }

}
