/*
 * Created on 2005-1-24
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.test.subject.parts;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;

import com.test.subject.IConstants;
import com.test.subject.SubjectEditorPlugin;
import com.test.subject.figures.SubjectFigure;
import com.test.subject.model.Attribute;
import com.test.subject.model.ModelPackage;
import com.test.subject.model.Node;
import com.test.subject.model.Subject;
import com.test.subject.policies.SubjectLayoutEditPolicy;

/**
 * @author zhanghao
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SubjectPart extends NodePart {

    protected Subject getSubject() {
        return (Subject) getModel();
    }

    public void performRequest(Request req) {
        if (req.getType() == RequestConstants.REQ_OPEN)
            getSubject().setCollapsed(!getSubject().isCollapsed());
    }

    public IFigure getContentPane() {
        return ((SubjectFigure) getFigure()).getAttributeFigure();
    }

    protected IFigure createFigure() {
        return new SubjectFigure();
    }

    protected void refreshVisuals() {
        super.refreshVisuals();
        SubjectFigure figure = (SubjectFigure) getFigure();
        figure.setName(((Node) this.getModel()).getName());
        if (!getSubject().isCollapsed()) {
            figure.setIcon(SubjectEditorPlugin.getImage(IConstants.IMG_FILE));
        } else {
            figure.setIcon(SubjectEditorPlugin.getImage(IConstants.IMG_FOLDER));
        }
    }

    protected void createEditPolicies() {
        //        installEditPolicy(EditPolicy.GRAPHICAL_NODE_ROLE, new NodeGraphicalNodeEditPolicy());
        super.createEditPolicies();
        installEditPolicy(EditPolicy.LAYOUT_ROLE, new SubjectLayoutEditPolicy());
    }

    protected List getModelChildren() {
        return getSubject().getAttributes();
    }

    public void activate() {
        super.activate();
        getSubject().eAdapters().add(this);
    }

    public void deactivate() {
        super.deactivate();
        getSubject().eAdapters().remove(this);
    }

    public void notifyChanged(Notification notification) {
        switch (notification.getFeatureID(ModelPackage.class)) {
        case ModelPackage.SUBJECT__COLLAPSED:
            SubjectFigure figure = ((SubjectFigure) getFigure());
            if (!getSubject().isCollapsed()) {
                figure.add(figure.getAttributeFigure());
            } else {
                figure.remove(figure.getAttributeFigure());
            }
            refreshVisuals();
            refreshSourceConnections();
            refreshTargetConnections();
            break;
        case ModelPackage.SUBJECT__ATTRIBUTES:
            refreshChildren();
			break;
        }
        super.notifyChanged(notification);
    }

    protected List getModelSourceConnections() {
        if (!getSubject().isCollapsed()) {
            return getSubject().getOutgoingConnections();
        } else {
            List l = new ArrayList();
            l.addAll(getSubject().getOutgoingConnections());
            for (Iterator iter = getSubject().getAttributes().iterator(); iter.hasNext();) {
                Attribute attribute = (Attribute) iter.next();
                l.addAll(attribute.getOutgoingConnections());
            }
            return l;
        }
    }

    protected List getModelTargetConnections() {
        if (!getSubject().isCollapsed()) {
            return getSubject().getIncomingConnections();
        } else {
            List l = new ArrayList();
            l.addAll(getSubject().getIncomingConnections());
            for (Iterator iter = getSubject().getAttributes().iterator(); iter.hasNext();) {
                Attribute attribute = (Attribute) iter.next();
                l.addAll(attribute.getIncomingConnections());
            }
            return l;
        }
    }

}