/*
 * Created on 2005-1-24
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.test.subject.ui;

import java.io.IOException;
import java.util.EventObject;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.xmi.impl.XMLResourceImpl;
import org.eclipse.gef.DefaultEditDomain;
import org.eclipse.gef.MouseWheelHandler;
import org.eclipse.gef.MouseWheelZoomHandler;
import org.eclipse.gef.SnapToGeometry;
import org.eclipse.gef.SnapToGrid;
import org.eclipse.gef.dnd.TemplateTransferDragSourceListener;
import org.eclipse.gef.editparts.ScalableFreeformRootEditPart;
import org.eclipse.gef.editparts.ZoomManager;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.rulers.RulerProvider;
import org.eclipse.gef.ui.actions.AlignmentAction;
import org.eclipse.gef.ui.actions.MatchHeightAction;
import org.eclipse.gef.ui.actions.MatchWidthAction;
import org.eclipse.gef.ui.actions.ToggleGridAction;
import org.eclipse.gef.ui.actions.ToggleRulerVisibilityAction;
import org.eclipse.gef.ui.actions.ToggleSnapToGeometryAction;
import org.eclipse.gef.ui.actions.ZoomInAction;
import org.eclipse.gef.ui.actions.ZoomOutAction;
import org.eclipse.gef.ui.palette.PaletteViewer;
import org.eclipse.gef.ui.palette.PaletteViewerProvider;
import org.eclipse.gef.ui.palette.FlyoutPaletteComposite.FlyoutPreferences;
import org.eclipse.gef.ui.parts.ContentOutlinePage;
import org.eclipse.gef.ui.parts.GraphicalEditorWithFlyoutPalette;
import org.eclipse.gef.ui.parts.ScrollingGraphicalViewer;
import org.eclipse.gef.ui.parts.TreeViewer;
import org.eclipse.gef.ui.rulers.RulerComposite;
import org.eclipse.jface.action.IAction;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.FileEditorInput;
import org.eclipse.ui.part.PageBook;
import org.eclipse.ui.views.contentoutline.IContentOutlinePage;

import com.test.subject.IConstants;
import com.test.subject.SubjectEditorPlugin;
import com.test.subject.dnd.DiagramTemplateTransferDropTargetListener;
import com.test.subject.model.Diagram;
import com.test.subject.model.ModelFactory;
import com.test.subject.parts.PartFactory;
import com.test.subject.parts.TreePartFactory;
import com.test.subject.rulers.SubjectRulerProvider;

/**
 * @author zhanghao TODO To change the template for this generated type comment
 *         go to Window - Preferences - Java - Code Style - Code Templates
 */
public class SubjectEditor extends GraphicalEditorWithFlyoutPalette {

	private Diagram diagram;

	private PaletteRoot paletteRoot;

	private Resource resource;

	private RulerComposite rulerComp;

	public Diagram getDiagram() {
		return this.diagram;
	}

	public SubjectEditor() {
		setEditDomain(new DefaultEditDomain(this));
	}

	protected Control getGraphicalControl() {
		return rulerComp;
	}

	protected FlyoutPreferences getPalettePreferences() {
		return new FlyoutPreferences() {
			public int getDockLocation() {
				return SubjectEditorPlugin.getDefault().getPreferenceStore().getInt(
						IConstants.PREF_PALETTE_DOCK_LOCATION);
			}

			public int getPaletteState() {
				return SubjectEditorPlugin.getDefault().getPreferenceStore().getInt(IConstants.PREF_PALETTE_STATE);
			}

			public int getPaletteWidth() {
				return SubjectEditorPlugin.getDefault().getPreferenceStore().getInt(IConstants.PREF_PALETTE_SIZE);
			}

			public void setDockLocation(int location) {
				SubjectEditorPlugin.getDefault().getPreferenceStore().setValue(IConstants.PREF_PALETTE_DOCK_LOCATION,
						location);
			}

			public void setPaletteState(int state) {
				SubjectEditorPlugin.getDefault().getPreferenceStore().setValue(IConstants.PREF_PALETTE_STATE, state);
			}

			public void setPaletteWidth(int width) {
				SubjectEditorPlugin.getDefault().getPreferenceStore().setValue(IConstants.PREF_PALETTE_SIZE, width);
			}
		};
	}

	protected void createGraphicalViewer(Composite parent) {
		rulerComp = new RulerComposite(parent, SWT.NONE);
		super.createGraphicalViewer(rulerComp);
		rulerComp.setGraphicalViewer((ScrollingGraphicalViewer) getGraphicalViewer());
	}

	protected void configureGraphicalViewer() {
		super.configureGraphicalViewer();
		ScalableFreeformRootEditPart root = new ScalableFreeformRootEditPart();
		getGraphicalViewer().setRootEditPart(root);
		getGraphicalViewer().setEditPartFactory(new PartFactory());

		IAction action = new ToggleGridAction(getGraphicalViewer());
		getActionRegistry().registerAction(action);
		action = new ToggleRulerVisibilityAction(getGraphicalViewer());
		getActionRegistry().registerAction(action);
		action = new ToggleSnapToGeometryAction(getGraphicalViewer());
		getActionRegistry().registerAction(action);

		action = new ZoomInAction(root.getZoomManager());
		getActionRegistry().registerAction(action);
		getSite().getKeyBindingService().registerAction(action);
		action = new ZoomOutAction(root.getZoomManager());
		getActionRegistry().registerAction(action);
		getSite().getKeyBindingService().registerAction(action);
		
		loadProperties();
	}

	protected void initializeGraphicalViewer() {
		getGraphicalViewer().setContents(this.diagram);
		getGraphicalViewer().addDropTargetListener(new DiagramTemplateTransferDropTargetListener(getGraphicalViewer()));

	}

	protected PaletteRoot getPaletteRoot() {
		if (this.paletteRoot == null) {
			this.paletteRoot = PaletteFactory.createPalette();
		}
		return this.paletteRoot;
	}

	protected PaletteViewerProvider createPaletteViewerProvider() {
		return new PaletteViewerProvider(getEditDomain()) {
			protected void configurePaletteViewer(PaletteViewer viewer) {
				super.configurePaletteViewer(viewer);
				viewer.addDragSourceListener(new TemplateTransferDragSourceListener(viewer));
			}
		};
	}

	/**
	 * Save properties to model
	 */
	protected void saveProperties() {
		diagram.setGridVisibility(((Boolean) getGraphicalViewer().getProperty(SnapToGrid.PROPERTY_GRID_VISIBLE))
				.booleanValue());
		diagram.setSnapToGeometry(((Boolean) getGraphicalViewer().getProperty(SnapToGeometry.PROPERTY_SNAP_ENABLED))
				.booleanValue());
		diagram
				.setRulerVisibility(((Boolean) getGraphicalViewer()
						.getProperty(RulerProvider.PROPERTY_RULER_VISIBILITY)).booleanValue());
		ZoomManager manager = (ZoomManager) getGraphicalViewer().getProperty(ZoomManager.class.toString());
		if (manager != null)
			diagram.setZoom(manager.getZoom());
	}

	protected void loadProperties() {
		// Ruler properties
		getGraphicalViewer().setProperty(RulerProvider.PROPERTY_VERTICAL_RULER,
				new SubjectRulerProvider(diagram.getLeftRuler()));
		getGraphicalViewer().setProperty(RulerProvider.PROPERTY_HORIZONTAL_RULER,
				new SubjectRulerProvider(diagram.getTopRuler()));
		getGraphicalViewer().setProperty(RulerProvider.PROPERTY_RULER_VISIBILITY,
				new Boolean(diagram.isRulerVisibility()));

		// Snap to Geometry property
		getGraphicalViewer().setProperty(SnapToGeometry.PROPERTY_SNAP_ENABLED, new Boolean(diagram.isSnapToGeometry()));

		// Grid properties
		getGraphicalViewer().setProperty(SnapToGrid.PROPERTY_GRID_ENABLED, new Boolean(diagram.isGridVisibility()));
		// Default grid spacing is 12x12, we set spacing to 15x15
		getGraphicalViewer().setProperty(SnapToGrid.PROPERTY_GRID_SPACING, new Dimension(15, 15));
		// We keep grid visibility and enablement in sync
		getGraphicalViewer().setProperty(SnapToGrid.PROPERTY_GRID_VISIBLE, new Boolean(diagram.isGridVisibility()));

		// Zoom
		ZoomManager manager = (ZoomManager) getGraphicalViewer().getProperty(ZoomManager.class.toString());
		if (manager != null)
			manager.setZoom(diagram.getZoom());
		// Scroll-wheel Zoom
		getGraphicalViewer().setProperty(MouseWheelHandler.KeyGenerator.getKey(SWT.CTRL),
				MouseWheelZoomHandler.SINGLETON);

	}

	public void doSave(IProgressMonitor monitor) {
		saveProperties();
		try {
			resource.save(null);
			getCommandStack().markSaveLocation();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void doSaveAs() {
	}

	protected void createActions() {
		super.createActions();

		IAction action=new AlignmentAction((IWorkbenchPart)this,PositionConstants.LEFT);
		getActionRegistry().registerAction(action);
		getSelectionActions().add(action.getId());

		action=new AlignmentAction((IWorkbenchPart)this,PositionConstants.CENTER);
		getActionRegistry().registerAction(action);
		getSelectionActions().add(action.getId());

		action=new AlignmentAction((IWorkbenchPart)this,PositionConstants.RIGHT);
		getActionRegistry().registerAction(action);
		getSelectionActions().add(action.getId());

		action=new AlignmentAction((IWorkbenchPart)this,PositionConstants.TOP);
		getActionRegistry().registerAction(action);
		getSelectionActions().add(action.getId());

		action=new AlignmentAction((IWorkbenchPart)this,PositionConstants.MIDDLE);
		getActionRegistry().registerAction(action);
		getSelectionActions().add(action.getId());

		action=new AlignmentAction((IWorkbenchPart)this,PositionConstants.BOTTOM);
		getActionRegistry().registerAction(action);
		getSelectionActions().add(action.getId());

		action=new MatchWidthAction((IWorkbenchPart)this);
		getActionRegistry().registerAction(action);
		getSelectionActions().add(action.getId());

		action=new MatchHeightAction((IWorkbenchPart)this);
		getActionRegistry().registerAction(action);
		getSelectionActions().add(action.getId());
}

	public void init(IEditorSite site, IEditorInput input) throws PartInitException {
		super.init(site, input);
		IFile file = ((FileEditorInput) getEditorInput()).getFile();
		URI fileURI = URI.createPlatformResourceURI(file.getFullPath().toString());
		resource = new XMLResourceImpl(fileURI);
		try {
			resource.load(null);
			diagram = (Diagram) resource.getContents().get(0);
		} catch (IOException e) {
			diagram = ModelFactory.eINSTANCE.createDiagram();
			resource.getContents().add(diagram);
		}
	}

	protected void setInput(IEditorInput input) {
		super.setInput(input);
		IFile file = ((FileEditorInput) getEditorInput()).getFile();
		setPartName(file.getName());
	}

	public void commandStackChanged(EventObject event) {
		firePropertyChange(IEditorPart.PROP_DIRTY);
		super.commandStackChanged(event);
	}

	public boolean isDirty() {
		return getCommandStack().isDirty();
	}

	public boolean isSaveAsAllowed() {
		return true;
	}

	public Object getAdapter(Class type) {
		if (type == IContentOutlinePage.class)
			return new OutlinePage();
		if (type == ZoomManager.class)
			return getGraphicalViewer().getProperty(ZoomManager.class.toString());
		return super.getAdapter(type);
	}

	class OutlinePage extends ContentOutlinePage {
		private PageBook pageBook;

		private Control outline;

		public OutlinePage() {
			super(new TreeViewer());
		}

		public void createControl(Composite parent) {
			pageBook = new PageBook(parent, SWT.NONE);
			outline = getViewer().createControl(pageBook);
			pageBook.showPage(outline);
			getSelectionSynchronizer().addViewer(getViewer());
			getViewer().setEditDomain(getEditDomain());
			// getViewer().setRootEditPart()
			getViewer().setEditPartFactory(new TreePartFactory());
			getViewer().setContents(getDiagram());
			super.createControl(parent);
		}

		public Control getControl() {
			return super.getControl();
		}

		public void dispose() {
			getSelectionSynchronizer().removeViewer(getViewer());
			super.dispose();
		}
	}

	// protected void initializePaletteViewer() {
	// super.initializePaletteViewer();
	// getPaletteViewer().addDragSourceListener(new
	// TemplateTransferDragSourceListener(getPaletteViewer()));
	// }
}
